package com.cool.hot100.binary_tree;

import org.junit.Test;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/08/30/16:17
 * DayNumber 1
 * Hard 1
 * Level ?
 */
public class Num108 {
    public TreeNode sortedArrayToBST(int[] nums) {
        return buildTree(nums, 0, nums.length - 1);
    }

    public TreeNode buildTree(int[] nums, int start, int end) {
        if (start > end) return null;
        if(start==end) return new TreeNode(nums[start]);
        TreeNode node = new TreeNode();
        if(end-start<2){
            node.val=nums[end];
            node.left= new TreeNode(nums[start]);
            return node;
        }
        int index = (start + end) / 2;
        node.val = nums[index];
        node.left = buildTree(nums, start, index - 1);
        node.right = buildTree(nums, index + 1, end);
        return node;
    }

    @Test
    public void test() {
        sortedArrayToBST(new int[]{-10, -3, 0, 5, 9});
    }
}
